package com.yuandian.dataflow.statemachine;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import javax.servlet.http.PushBuilder;

import org.apache.ratis.protocol.Message;
import org.apache.ratis.thirdparty.com.google.protobuf.ByteString;

import com.yuandian.dataflow.statemachine.state.WorkerState;

import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Getter
@Setter
public class Query implements Message,Serializable {

    public static enum Type {
        /**
         * 同步WorkerState状态. 
         */
        GET_STATE,
    }

    private  Type type;
    private  Object value;
    public Query(Type t, WorkerState ws) {
        this.type = t;
        this.value = ws;
    }

    @Override
    public ByteString getContent() {
        try {
            var output = ByteString.newOutput();
            var outputStream = new ObjectOutputStream(output);
            outputStream.writeObject(this);
            outputStream.close();
            output.close();
            return  output.toByteString();
        } catch (IOException  e) {
            e.printStackTrace();
        }
        return null;
    }
    
}
